// closure to avoid namespace collision
(function(){
	// creates the plugin
    tinymce.create('tinymce.plugins.mygct', {
        /**
         * Initializes the plugin, this will be executed after the plugin has been created.
         * This call is done before the editor instance has finished it's initialization so use the onInit event
         * of the editor instance to intercept that event.
         *
         * @param {tinymce.Editor} ed Editor instance that the plugin is initialized in.
         * @param {string} url Absolute URL to where the plugin is located.
         */
        init : function(ed, url) {
            
        },
 
        /**
         * Creates control instances based in the incomming name. This method is normally not
         * needed since the addButton method of the tinymce.Editor class is a more easy way of adding buttons
         * but you sometimes need to create more complex controls like listboxes, split buttons etc then this
         * method can be used to create those.
         *
         * @param {String} n Name of the control to create.
         * @param {tinymce.ControlManager} cm Control manager to use inorder to create new control.
         * @return {tinymce.ui.Control} New control instance or null if no control was created.
         */
        createControl : function(n, cm) {
            if(n=='mygct_button'){
                var mlb = cm.createListBox('mygct_buttonList', {
                     title : 'Guitar',
                     onselect : function(v) { //Option value as parameter
					 
							//var width = 
										//var W = jQuery(window).width(); 
										//var H = jQuery(window).height(); 
										//W = 800;
										//H = H - 84;
					 
							switch(v) {
								case 'chord':
									tb_show( 'CHORD', '#TB_inline?inlineId=chordy' );
									break;
								case 'tab':
									tb_show( 'TAB (work in progress)', '#TB_inline?width=' + 100 + '&height=' + 100 + '&inlineId=taby' );
									break;
								case 'jtab':
									tb_show( 'JTAB (work in progress)', '#TB_inline?width=' + 800 + '&height=' + 800 + '&inlineId=jtaby' );
									break;
								case 'scale':
									tb_show( 'SCALE (work in progress)', '#TB_inline?width=' + 800 + '&height=' + 800 + '&inlineId=scaley' );
									break;
								default:break;
							}
                     }
                });
 
                // Add some values to the list box
                mlb.add('Chord', 'chord');
				mlb.add('Tab', 'tab');
				mlb.add('jTab', 'jtab');
				mlb.add('Scale', 'scale');
 
                // Return the new listbox instance
                return mlb;
             }
             
             return null;
        },
 
        /**
         * Returns information about the plugin as a name/value array.
         * The current keys are longname, author, authorurl, infourl and version.
         *
         * @return {Object} Name/value array containing information about the plugin.
         */
        getInfo : function() {
            return {
                longname : 'Shortcode selector',
                author : 'g',
                authorurl : 'http://marquex.es',
                infourl : 'http://marquex.es/387/adding-a-select-box-to-wordpress-tinymce-editor',
                version : "0.1"
            };
        }
    });
	
	// registers the plugin. DON'T MISS THIS STEP!!!
	tinymce.PluginManager.add('mygct', tinymce.plugins.mygct);
	


	/***
	 * HTML Thickbox
	 ***/
	// executes this when the DOM is ready
	jQuery(function(){
		// creates a form to be displayed everytime the button is clicked
		// you should achieve this using AJAX instead of direct html code like this
		var form = jQuery(
		// CSS : to change TB width & height
		'\
		<div id="mygct-form">\
			<style type="text/css">\
				#TB_ajaxContent[style], #TB_window {\
					width : 950px !important;\
					height : 704px !important;\
					overflow: hidden;\
				}\
				\
				.postbox {\
					float: left;\
					padding: 0px 0px 7px 15px;\
					margin: 6px 4px 1px;\
				}\
				.bold {\
					font-weight: bold;\
				}\
				.auto {\
					margin: 0 auto;\
				}\
				.right {\
					float: right;\
				}\
				.left {\
					float: left;\
				}\
				#table_scale{\
					border-spacing:7px;\
				}\
				.chordContainer{\
					width:150px;\
					height:150px;\
				}\
				#thick_tab {\
					padding: 35px;\
				}\
				#thick_jtab{\
					padding: 35px;\
				}\
				#thick_gamme{\
					padding: 35px;\
				}\
			</style>'
			+ // CHORD
			'\
			<div id="chordy">\
				<div id="thick_chord">\
					\
				</div>\
			</div>\
			'
			+ // TAB
			'\
			<div id="taby">\
				<div id="thick_tab">\
					<table id="mygct-table2" class="gform-table" cellpadding="0" cellspacing="0" width="100px">\
						<tr id="ea">\
							<td style="width:30px;">E</td>\
							<td style="width:40px;"><input type="text" id="ea1" style="width:40px;" value="5 8"></td>\
							<td style="width:40px;"><input type="text" id="ea2" style="width:40px;"></td>\
							<td class="end" style="width:40px;"><input type="text" id="ea3" style="width:40px;"></td>\
						</tr>\
						<tr id="b">\
							<td>B</td>\
							<td><input type="text" id="b1" style="width:40px;"></td>\
							<td><input type="text" id="b2" style="width:40px;"  value="5 8"></td>\
							<td class="end"><input type="text" id="b3" style="width:40px;"></td>\
						</tr>\
						<tr id="g">\
							<td>G</td>\
							<td><input type="text" id="g1" style="width:40px;"></td>\
							<td><input type="text" id="g2" style="width:40px;"></td>\
							<td class="end"><input type="text" id="g3" style="width:40px;"  value="5 7"></td>'
							+
							'<td><input type="button" id="addCol" class="button-secondary" value="+" name="submit" /></td>'
							+
						'</tr>\
						<tr id="d">\
							<td>D</td>\
							<td><input type="text" id="d1" style="width:40px;"></td>\
							<td><input type="text" id="d2" style="width:40px;"></td>\
							<td class="end"><input type="text" id="d3" style="width:40px;"></td>\
						</tr>\
						<tr id="a">\
							<td>A</td>\
							<td><input type="text" id="a1" style="width:40px;"></td>\
							<td><input type="text" id="a2" style="width:40px;"></td>\
							<td class="end"><input type="text" id="a3" style="width:40px;"></td>\
						</tr>\
						<tr id="eg">\
							<td>E</td>\
							<td><input type="text" id="eg1" style="width:40px;"></td>\
							<td><input type="text" id="eg2" style="width:40px;"></td>\
							<td class="end"><input type="text" id="eg3" style="width:40px;"></td>\
						</tr>\
					</table>'
					+
					'<p><input type="button" id="thick_tab_btn" class="button-secondary" value="Test"/></p>'
					+
					'<div id="tab_thick_tab"></div>\
					<div>\
						<input type="button" id="mygct2-submit" class="button-primary left" value="Add to Post / Page" name="submit" />\
					</div>\
				</div>\
			</div>\
			'
			+ // jTab
			'\
			<div id="jtaby">\
				<div id="thick_jtab">\
					<p>\
						<input id="user_notation" size="60" value="Bm $3 4 4h5p3h4 5 $2 3 5 7 7h8p7 5/7">\
						<input type="button" class="button-secondary" value="Test it now !" onclick="jtab.render(\'tab\',$(\'user_notation\').value);">\
						<div id="tab"></div>\
					</p>\
					<div>\
						<input type="button" id="free-submit" class="button-primary" value="Add to Post / Page" name="submit" />\
					</div>\
				</div>\
			</div>'
			+ //SCALE				
			'\
			<div id="scaley">\
				\
							<div id="thick_gamme" >\
								<table id="scale-table" class="gform-table">\
									<tr id="endChord">\
										<td style="width:30px;">\
											<select name="scale_name" id="scale_note">\
												<option value="1">C</option>\
												<option value="2">C#</option>\
												<option value="3">D</option>\
												<option value="4">D#</option>\
												<option value="5">E</option>\
												<option value="6">F</option>\
												<option value="7">F#</option>\
												<option value="8">G</option>\
												<option value="9">G#</option>\
												<option value="10">A</option>\
												<option value="11">A#</option>\
												<option value="12">B</option>\
											</select>\
										<td style="width:30px;">\
											<select name="scale_type" id="scale_type_id">\
												<option value="major">major</option>\
												<option value="pentatonic major">pentatonic major</option>\
												<option value="blues">blues</option>\
											</select>\
									</tr>\
								</table>\
								<!--<p id="pscale" class="submit">\
									<input type="button" id="scalebtn" class="button-secondary" value="Test"/>\
									<input type="button" id="scale_btn_add" class="button-primary" value="Add" name="submit" />\
								</p>-->\
								<p>\
								<table id="table_scale">\
									<tr id="trscale_deg"></tr>\
									<tr id="trscale"></tr>\
									<tr id="trscale2"></tr>\
									<tr id="trscale3"></tr>\
								</table></p>\
					\
			</div>\
			');

		// Interface hide show
		form.find('#tab_title1').click(function(){
			jQuery("#tab_inside1").toggle();
		});
		form.find('#tab_title2').click(function(){
			jQuery("#tab_inside2").toggle();
		});
		form.find('#tab_title3').click(function(){
			jQuery("#tab_inside3").toggle();
		});
		form.find('#tab_title4').click(function(){
			jQuery("#tab_inside4").toggle();
		});
		
		/**********/
		/*  INIT  */
		/**********/
				
		//Init Tab
		var maxCol = 3;
		var table = form.find('table');
		form.appendTo('body');//.hide();

		//Ajoute l'accord selectionn
		form.find('#mygct-submit').click(function(){
			// defines the options and their default values
			// again, this is not the most elegant way to do this
			// but well, this gets the job done nonetheless
			var options = { 'chord' : 'A','color' : 'Maj'};
			var shortcode = "[jtab phrase='";
			
			for( var index in options) {
				var value = table.find('#mygct-' + index).val();
				
				// attaches the attribute to the shortcode only if it's different from the default value
				//if ( value !== options[index] )
					shortcode += value;
					//console.log(value);
			};
			shortcode += "']";
			// inserts the shortcode into the active editor
			tinyMCE.activeEditor.execCommand('mceInsertContent', 0, shortcode);
		});
		
		//Test dans thickbox avant insertion tab
		form.find('#thick_tab_btn').click(function(){
			tabcode = "";
			var gstring = ['ea','b','g','d','a','eg'];
			for (var j=1;j<=maxCol;j++) {
				for (var i=1;i<=6;i++){ 
					tabcode += '.$'+i+'.' + table.find('#'+gstring[i-1]+j+'').val();
				}
				tabcode += ' ';
			}
			jtab.render('tab_thick_tab',tabcode);
		});
		//exemple dbut
		jtab.render('tab_thick_tab','.$1.5 8.$2..$3..$4..$5..$6. .$1..$2.5 8.$3..$4..$5..$6. .$1..$2..$3.5 7.$4..$5..$6. ');
		//exemple free text
		jtab.render('tab','Bm $3 4 4h5p3h4 5 $2 3 5 7 7h8p7 5/7');
		
		
		//Ajout Tab entre au clavier
		form.find('#mygct2-submit').click(function(){
			tabcode = "[jtab phrase='";
			var gstring = ['ea','b','g','d','a','eg'];
			for (var j=1;j<=maxCol;j++) {
				for (var i=1;i<=6;i++){ 
					tabcode += '.$'+i+'.' + table.find('#'+gstring[i-1]+j+'').val();
					//console.log('#'+gstring[i-1]+i);
				}
				tabcode += ' ';
			}
			tabcode += "']";
			tinyMCE.activeEditor.execCommand('mceInsertContent', 0, tabcode);
		});
		
		
		//Ajoute la free tab
		form.find('#free-submit').click(function(){
			var shortcode = "[jtab phrase='";
			shortcode += $('user_notation').value;
			shortcode += "']";
			// inserts the shortcode into the active editor
			tinyMCE.activeEditor.execCommand('mceInsertContent', 0, shortcode);
		});

		//ajout col au clic sur btn Add
		form.find('#addCol').click(function(){
			//alert('colonne supp ?');
			maxCol += 1;
			var eacase = "<td style='width:40px;'><input type='text' id='ea"+maxCol+"' style='width:40px;'></td>"
			var bcase = "<td style='width:40px;'><input type='text' id='b"+maxCol+"' style='width:40px;'></td>"
			var gcase = "<td style='width:40px;'><input type='text' id='g"+maxCol+"' style='width:40px;'></td>"
			var dcase = "<td style='width:40px;'><input type='text' id='d"+maxCol+"' style='width:40px;'></td>"
			var acase = "<td style='width:40px;'><input type='text' id='a"+maxCol+"' style='width:40px;'></td>"
			var egcase = "<td style='width:40px;'><input type='text' id='eg"+maxCol+"' style='width:40px;'></td>"
			
			jQuery('#ea td:eq(-1)').after(eacase);
			jQuery('#b td:eq(-1)').after(bcase);
			jQuery('#g td:eq(-2)').after(gcase);
			jQuery('#d td:eq(-1)').after(dcase);
			jQuery('#a td:eq(-1)').after(acase);
			jQuery('#eg td:eq(-1)').after(egcase);			
		});
		
		//SCALE JS
		var note = ["C", "C#", "D", "D#", "E", "F", "F#", "G", "G#", "A", "A#", "B",
					"C", "C#", "D", "D#", "E", "F", "F#", "G", "G#", "A", "A#", "B"];
		console.log("note : " + note);
		
		var scales = {//       C D E F G A B
					"major" : [2,2,1,2,2,2,1],
					"pentatonic major" : [2,2,3,2,3],
					"blues" : [3,2,1,1,3,2]
		};
		console.log("scales['major'] : " + scales['major']);
		
		
		//exemple dbut
		jQuery("#trscale_deg").html(
			"<td class='bold'>Degres /</td>" +
			"<td id='skalenb' align='middle'> 1 2 3 4 5 6 7</td>"
			/*+ "<td><a href='#' id='TB_closeWindowButton'><div class='tb-close-icon left' width='10px'></div></a></td>"*/
			);
		jQuery("#trscale").html(
			"<td class='bold'>C major :</td>" +
			"<td id='skale' align='middle'> C D E F G A B</td>"
			+ "<td><input id='scalebtn_add_maj' type='button' class='button-primary' value='Add'/></td>"
			);
		jQuery("#trscale2").html(
			"<td class='bold'>" + "V IV I : </td>" +
			"<td id='skalecqu'>F G C</td>\
			<td><input id='scalebtn_add_qcu' type='button' class='button-primary' value='Add'/></td>");	
		jQuery("#trscale3").html(
			"<td class='bold'>" + "II VI I : </td>" +
			"<td id='skaledcu'>D G C</td>\
			<td><input id='scalebtn_add_dcu' type='button' class='button-primary' value='Add'/></td>");			
		
		//si modif select scale_note
		jQuery('#scale_note').on('change',function(){	
				var note_sel = jQuery('#scale_note option:selected').val();
				var scale_sel = jQuery('#scale_type_id option:selected').val();
				console.log("note_sel : " + note_sel);
				console.log("scale_sel : "+ scale_sel);
				
				// incrmenter gamme maj % note_sel
				var temp_scale = [];
				
				temp_scale[0] = parseInt(note_sel);
				
				switch(scale_sel){ 
					case "major":
						for (var i=1; i<7; i++){
							temp_scale[i] = (temp_scale[i-1] + scales['major'][i-1]);
						}
						console.log("temp_scale : " + temp_scale);

						var resp_scale= [];
						for (var i=0; i<7; i++){
							resp_scale[i] = note[temp_scale[i]-1];
						}
						console.log("resp_scale : " + resp_scale);
						jQuery("#trscale").html(
							"<td class='bold'>" + note[note_sel-1] + " major :</td>" +
							"<td id='skale' align='middle'>" + resp_scale.join(" ") + "</td>\
							<td><input id='scalebtn_add_maj' type='button' class='button-primary' value='Add'/></td>");
												
						var qcu = [];
						qcu[0] = resp_scale[3];
						qcu[1] = resp_scale[4];
						qcu[2] = resp_scale[0];				
						jQuery("#trscale2").html(
							"<td class='bold'>" + "V IV I : </td>" +
							"<td id='skaleqcu'>" + qcu.join(" ") + "</td>\
							<td><input id='scalebtn_add_qcu' type='button' class='button-primary' value='Add'/></td>");
						
						var dcu = [];
						dcu[0] = resp_scale[1];
						dcu[1] = resp_scale[4];
						dcu[2] = resp_scale[0];
						jQuery("#trscale3").html(
							"<td class='bold'>" + "II VI I : </td>" +
							"<td id='skaledcu'>" + dcu.join(" ") + "</td>\
							<td><input id='scalebtn_add_dcu' type='button' class='button-primary' value='Add'/></td>");
						break; 
					
					case "pentatonic major": 
						for (var i=1; i<5; i++){
							temp_scale[i] = (temp_scale[i-1] + scales['pentatonic major'][i-1]);
						}
						console.log("temp_scale : " + temp_scale);

						var resp_scale= [];
						for (var i=0; i<5; i++){
							resp_scale[i] = note[temp_scale[i]-1];
						}
						console.log("resp_scale : " + resp_scale);
						jQuery("#trscale").html(
							"<td class='bold'> pentatonic major :</td>" +
							"<td id='skalepenta'>" + resp_scale.join(" ") + "</td>\
							<td><input id='scalebtn_add_penta' type='button' class='button-primary' value='Add'/></td>");
						jQuery("#trscale2").html("");
						jQuery("#trscale3").html("");
						break;
					
					case "blues": 
						for (var i=1; i<6; i++){
							temp_scale[i] = (temp_scale[i-1] + scales['blues'][i-1]);
						}
						console.log("temp_scale : " + temp_scale);

						var resp_scale= [];
						for (var i=0; i<6; i++){
							resp_scale[i] = note[temp_scale[i]-1];
						}
						console.log("resp_scale : " + resp_scale);
						jQuery("#trscale").html(
							"<td class='bold'> blues :</td>" +
							"<td id='skaleblues'>" + resp_scale.join(" ") + "</td>\
							<td><input id='scalebtn_add_blues' type='button' class='button-primary' value='Add'/></td>");
						jQuery("#trscale2").html("");
						jQuery("#trscale3").html("");
						break;
					
					default: 
						break; 
				}
		}); //scalebtn	

		
		//si modif select scale_type_id IDEM
		jQuery('#scale_type_id').on('change',function(){	
				var note_sel = jQuery('#scale_note option:selected').val();
				var scale_sel = jQuery('#scale_type_id option:selected').val();
				console.log("note_sel : " + note_sel);
				console.log("scale_sel : "+ scale_sel);
				
				// incrmenter gamme maj % note_sel
				var temp_scale = [];
				
				temp_scale[0] = parseInt(note_sel);
				
				switch(scale_sel){ 
					case "major":
						for (var i=1; i<7; i++){
							temp_scale[i] = (temp_scale[i-1] + scales['major'][i-1]);
						}
						console.log("temp_scale : " + temp_scale);

						var resp_scale= [];
						for (var i=0; i<7; i++){
							resp_scale[i] = note[temp_scale[i]-1];
						}
						console.log("resp_scale : " + resp_scale);
						jQuery("#trscale").html(
							"<td class='bold'>" + note[note_sel-1] + " major :</td>" +
							"<td id='skale' align='middle'>" + resp_scale.join(" ") + "</td>\
							<td><input id='scalebtn_add_maj' type='button' class='button-primary' value='Add'/></td>");
							console.log("skale : "+resp_scale.join(" "));
												
						var qcu = [];
						qcu[0] = resp_scale[3];
						qcu[1] = resp_scale[4];
						qcu[2] = resp_scale[0];				
						jQuery("#trscale2").html(
							"<td class='bold'>" + "V IV I : </td>" +
							"<td id='skaleqcu'>" + qcu.join(" ") + "</td>\
							<td><input id='scalebtn_add_qcu' type='button' class='button-primary' value='Add'/></td>");
						
						var dcu = [];
						dcu[0] = resp_scale[1];
						dcu[1] = resp_scale[4];
						dcu[2] = resp_scale[0];
						jQuery("#trscale3").html(
							"<td class='bold'>" + "II VI I : </td>" +
							"<td id='skaledcu'>" + dcu.join(" ") + "</td>\
							<td><input id='scalebtn_add_dcu' type='button' class='button-primary' value='Add'/></td>");
						break; 
					
					case "pentatonic major": 
						for (var i=1; i<5; i++){
							temp_scale[i] = (temp_scale[i-1] + scales['pentatonic major'][i-1]);
						}
						console.log("temp_scale : " + temp_scale);
						var resp_scale= [];
						for (var i=0; i<5; i++){
							resp_scale[i] = note[temp_scale[i]-1];
						}
						console.log("resp_scale : " + resp_scale);
						jQuery("#trscale").html(
							"<td class='bold'> pentatonic major :</td>" +
							"<td id='skalepenta'>" + resp_scale.join(" ") + "</td>\
							<td><input id='scalebtn_add_penta' type='button' class='button-primary' value='Add'/></td>");
						jQuery("#trscale2").html("");
						jQuery("#trscale3").html("");
						break;
					
					case "blues": 
						for (var i=1; i<6; i++){
							temp_scale[i] = (temp_scale[i-1] + scales['blues'][i-1]);
						}
						console.log("temp_scale : " + temp_scale);
						var resp_scale= [];
						for (var i=0; i<6; i++){
							resp_scale[i] = note[temp_scale[i]-1];
						}
						console.log("resp_scale : " + resp_scale);
						jQuery("#trscale").html(
							"<td class='bold'> blues :</td>" +
							"<td id='skaleblues'>" + resp_scale.join(" ") + "</td>\
							<td><input id='scalebtn_add_blues' type='button' class='button-primary' value='Add'/></td>");
						jQuery("#trscale2").html("");
						jQuery("#trscale3").html("");
						break;
					
					default: 
						break; 
				}
		}); //scalebtn
		
		//Ajoute la scale (attention  dlguer l'evenement car bouton cr dynamiqmt)
		jQuery('#table_scale').on('click','#scalebtn_add_maj',function() {
			var shortcode = "Gamme majeure [jtab phrase='";
			shortcode += jQuery('#skale').text();
			shortcode += "']";
			console.log("SKALE / "+shortcode);
			tinyMCE.activeEditor.execCommand('mceInsertContent', 0, shortcode);
		});
		
		//Ajoute 4-5-1
		jQuery('#table_scale').on('click','#scalebtn_add_qcu',function() {
			var shortcode = "IV V I [jtab phrase='";
			shortcode += jQuery('#skalecqu').text();
			shortcode += "']";
			tinyMCE.activeEditor.execCommand('mceInsertContent', 0, shortcode);
		});
		//Ajoute 2-5-1
		jQuery('#table_scale').on('click','#scalebtn_add_dcu',function() {
			var shortcode = "II V I [jtab phrase='";
			shortcode += jQuery('#skaledcu').text();
			shortcode += "']";
			tinyMCE.activeEditor.execCommand('mceInsertContent', 0, shortcode);
		});
		//Ajoute penta
		jQuery('#table_scale').on('click','#scalebtn_add_penta',function() {
			var shortcode = "Penta [jtab phrase='";
			shortcode += jQuery('#skalepenta').text();
			shortcode += "']";
			tinyMCE.activeEditor.execCommand('mceInsertContent', 0, shortcode);
		});
		//Ajoute blues
		jQuery('#table_scale').on('click','#scalebtn_add_blues',function() {
			var shortcode = "Blues [jtab phrase='";
			shortcode += jQuery('#skaleblues').text();
			shortcode += "']";
			tinyMCE.activeEditor.execCommand('mceInsertContent', 0, shortcode);
		});
		
		//TEST load html file
		jQuery( "#chordy" ).load( "../wp-content/plugins/guitar-chords-and-tabs/html/chordsandtabs.html", function( response, status, xhr ) {
		  if ( status == "error" ) {
			var msg = "Sorry but there was an error: ";
			$( "#error" ).html( msg + xhr.status + " " + xhr.statusText );
		  }
		});
		
		//Init Chord
		//jtab.render('tab_thick_chord','G');
		
	}); //jQuery function
	
	
	
	
})()

